/*****************************************************************************
 *
 *  jobmanagerdialog.h -- Wrap a JobManagerWidget in a window.
 *
 *  Copyright (C) 2010 Starbuck <starbuck@labdv.com>
 *  All rights reserved.
 *
 *  This file is part of the Gui4 module of the DVDx 4 application.
 *
 *  GNU Lesser General Public License Usage
 *  This file may be used under the terms of the GNU Lesser General
 *  Public License version 2.1 as published by the Free Software
 *  Foundation and appearing in the file LICENSE.LGPL included in the
 *  packaging of this file.  Please review the following information to
 *  ensure the GNU Lesser General Public License version 2.1 requirements
 *  will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
 *
 *  GNU General Public License Usage
 *  Alternatively, this file may be used under the terms of the GNU
 *  General Public License version 3.0 as published by the Free Software
 *  Foundation and appearing in the file LICENSE.GPL included in the
 *  packaging of this file.  Please review the following information to
 *  ensure the GNU General Public License version 3.0 requirements will be
 *  met: http://www.gnu.org/copyleft/gpl.html.
 *
 *****************************************************************************/

#ifndef JOBMANAGERDIALOG_H
#define JOBMANAGERDIALOG_H

#include "../job/jobmanager.h"
#include "jobmanagerwidget.h"
#include "consoledialog.h"
#include <QMap>
#include <QDialog>
#include <QString>
#include <QTextEdit>
#include <QLabel>
#include <QProgressBar>
#include <QIcon>
#include <QPushButton>
#include <QGroupBox>
#include <QLayout>
#include <QProcess>
#include <QMainWindow>

class JobManagerDialog : public QDialog
{
	Q_OBJECT

public:
	JobManagerDialog(const QString &, QWidget *);

	inline JobManagerWidget *getManagerWidget() { return jobManagerWidget; };
	bool isIdle();

	inline void setFinished() { finished = true; };
	void setNoConsoleButton(bool);
	void setVerbosity(const int);

public slots:
	void adjustGuiSize();
	void modalConsoleHidden();

signals:
	void hidden();

protected:
	void center();	// center on parent
	void hideEvent(QHideEvent *);
	void closeEvent(QCloseEvent *);

protected:
	QVBoxLayout *mainLayout;
	JobManagerWidget* jobManagerWidget;

	QWidget *mainConsole;

	bool finished;
	bool showConsoleButton;
	int verbosity;
};

#endif
